<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomDirfRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getRelatCustomDirf($parameters, $filters) {

        foreach($filters as $key=>$value){
            if($value['columnName'] == 'NRESTRUTLEGAL' || $value['columnName'] == 'NRESTRUTGEREN' || $value['columnName'] == 'NREVENTOM')
                unset($filters[$key]);
        }
        $conditions = "";
        $conditions = Util::createQueryFiltered($filters);
        
        //Montagem do select e group by em função dos dados do vínculo
        if($parameters['IDDADOSVINC'] == 'S') {
          $select = "RES.*";
          $group  = "ORDER BY RES.NMESTRUTLEGAL, RES.NMPESSOA, RES.CDRECEITA, RES.MES, RES.NMITEM, RES.NREVENTOM";
        } else {
          $select = " RES.NRORG,
                      RES.NRESTRUTLEGAL,
                      RES.NMESTRUTLEGAL,
                      RES.NRESTRUTGEREN,
                      RES.NMESTRUTGEREN,
                      NULL NRVINCULOM,
                      NULL NRPESSOA,
                      NULL NRCPFPESSOA,
                      NULL NMPESSOA,
                      RES.CDRECEITA,
                      RES.MES,
                      RES.NMITEM,
                      RES.DSITEM,
                      RES.NRTIPOINCIDE,
                      RES.NMTIPOINCIDE,
                      NULL NRTIPOMOVIMENT,
                      NULL NMTIPOMOVIMENT,
                      NULL NREVENTOM,
                      SUM(RES.VREVENTOFOLHA) VREVENTOFOLHA";

          $group  = "GROUP BY RES.NRORG, RES.NRESTRUTLEGAL, RES.NMESTRUTLEGAL, RES.NRESTRUTGEREN, RES.NMESTRUTGEREN,
                              RES.CDRECEITA, RES.MES, RES.NMITEM, RES.DSITEM, RES.NRTIPOINCIDE, RES.NMTIPOINCIDE/*,
                              RES.NRTIPOMOVIMENT, RES.NMTIPOMOVIMENT, RES.NREVENTOM*/
                     ORDER BY RES.NMESTRUTLEGAL, /*RES.NMPESSOA,*/ RES.CDRECEITA, RES.MES, RES.NMITEM/*, RES.NREVENTOM*/";
        }

      if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
          $listEstrutLegal = array_map(function($estrutlegal) {
              return $estrutlegal;
          },
          $parameters['NRESTRUTLEGAL']);
          $condEstrutLegal = "AND VH.NRESTRUTLEGAL IN (" . implode(',',$listEstrutLegal) . ")";
      } else {
        $condEstrutLegal = "";
      }

      if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          $listEstrutGeren = array_map(function($estrutgeren) {
              return $estrutgeren;
          },
          $parameters['NRESTRUTGEREN']);
          $condEstrutGeren = "AND VH.NRESTRUTGEREN IN (" . implode(',',$listEstrutGeren) . ")";
      } else {
        $condEstrutGeren = "";
      }

      if(array_key_exists('NREVENTOM', $parameters)){
          $condicaoEventos = 'AND FPA_ITECALCFOLHA.NREVENTOM IN ('.$parameters['NREVENTOM'].')';
      }else {
          $condicaoEventos = ' ';
      }
      $query = $this->entityManager->getConnection()->prepare("
        SELECT GPE_VINCULOM.*
          FROM (SELECT
                 $select
                FROM (SELECT
                        VH.NRORG,
                        VH.NRESTRUTLEGAL,
                        EML.NMESTRUTURAM NMESTRUTLEGAL,
                        VH.NRESTRUTGEREN,
                        EMG.NMESTRUTURAM NMESTRUTGEREN,
                        VM.NRVINCULOM,
                        VM.NMVINCULOM,
                        PH.NRPESSOA,
                        PH.NRCPFPESSOA,
                        PH.NMPESSOA,
                        CASE
                          WHEN ICF.NREVENTOM = 870 AND CF.NRTIPOMOVIMENT = 19 THEN '3562' WHEN ICF.NREVENTOM != 870 AND CF.NRTIPOMOVIMENT = 19 THEN NULL/*WHEN ICF.NREVENTOM = 870 THEN '3562|'*/
                          ELSE LPAD(VE.CODRECEITA, 4, '0')
                        END CDRECEITA,
                        CASE
                          WHEN INSTR(GIT.NMITEM, '-13S'/*'-13S'*/) > 0 THEN '13' /*Verifica se o item é do 13º salário (Ex.: se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
                          ELSE TO_CHAR(CF.DTOCORRENCIA, 'mm')
                        END MES,
                        GIT.NRITEM,
                        GIT.NMITEM,
                        GIT.DSITEM,
                        IEV.NRTIPOINCIDE,
                        TPI.NMTIPOINCIDE,
                        CF.NRTIPOMOVIMENT,
                        TPM.NMTIPOMOVIMENT,
                        ICF.NREVENTOM,
                        FPA_EVENTOH.NMEVENTOH,
                        CASE
                          WHEN REPLACE(GIT.NMITEM, '-13S', '') IN ('RTRT','RTPO')
                           AND (SELECT SUM(IC.VREVENTOFOLHA)
                                 FROM FPA_ITECALCFOLHA IC
                                WHERE IC.NRORG = CF.NRORG
                                  AND IC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                  AND IC.NRVINCULOM = VM.NRVINCULOM
                                  AND IC.NREVENTOM = 3200
                                  AND TO_CHAR(VM.DTRESCISAOVINC,'MM') = TO_CHAR(CF.DTOCORRENCIA,'MM')
                                  AND INSTR(GIT.NMITEM, '-13S') = 0 ) = 0
                          THEN 0
                          ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
                        END VREVENTOFOLHA
                      FROM GPE_VINCULOM VM
                      JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                          AND VH.NRVINCULOM = VM.NRVINCULOM
                      /*Estrutura Legal*/
                      JOIN ESTRUTURAM EML ON EML.NRORG        = VH.NRORG
                                         AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
                      /*Estrutura Gerencial*/
                      JOIN ESTRUTURAM EMG ON EMG.NRORG        = VH.NRORG
                                         AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
                      /*Código da receita do vínculo em questão (item 3.5)*/
                      LEFT JOIN GPE_VINCULOEMPREG VE ON ( VE.NRORG IS NULL OR VE.NRORG = 0 OR VE.NRORG = VM.NRORG )
                                                    AND VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
                      /*CPF e Nome do vínculo em questão (item 3.6)*/
                      JOIN GPE_PESSOA  PE ON PE.NRORG    = VM.NRORG
                                         AND PE.NRPESSOA = VM.NRPESSOA
                      JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                                         AND PH.NRPESSOA = PE.NRPESSOA
                      /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                      JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = VM.NRORG OR GIT.NRORG = 0 )
                                               AND GIT.NRGRPINCIDE  = :P_NRGRPDIRF
                      JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = VM.NRORG OR IEV.NRORG = 0 )
                                               AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                      JOIN FPA_TIPOINCIDE  TPI ON /*( TPI.NRORG = VM.NRORG OR TPI.NRORG = 0 )
                                               AND */TPI.NRTIPOINCIDE = IEV.NRTIPOINCIDE
                      JOIN FPA_CALCULOFOLHA  CF ON CF.NRORG          = VM.NRORG
                                               AND ( CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 2)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP-13S', 4)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 8)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 4)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 8)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 4)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 8)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 4)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 8)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 4)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
                                                     OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1))
                                               AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                                               AND CF.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :P_COMPETENCIA ), 'YEAR' ) AND :P_COMPETENCIA
                      JOIN FPA_TIPOMOVIMENT TPM ON ( TPM.NRORG = CF.NRORG OR TPM.NRORG = 0 )
                                               AND TPM.NRTIPOMOVIMENT     = CF.NRTIPOMOVIMENT
                      JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = VM.NRORG
                                               AND ICF.NRVINCULOM     = VM.NRVINCULOM
                                               AND ICF.NREVENTOM      = IEV.NREVENTOM
                                               AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                      JOIN FPA_EVENTOH ON ICF.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                      AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) 
                                                                          FROM FPA_EVENTOH E 
                                                                         WHERE E.NRORG = FPA_EVENTOH.NRORG
                                                                           AND E.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                                                           AND E.DTMESCOMPETENC <= :P_COMPETENCIA)
                      WHERE VM.NRORG = :P_NRORG
                        AND ( VM.DTRESCISAOVINC <> VM.DTADMISSAOVINC OR VM.DTRESCISAOVINC IS NULL )
                        AND ( VM.DTRESCISAOVINC IS NULL
                              OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :P_COMPETENCIA ), 'YEAR' ) ) )
                        AND GIT.NRITEM != 99 /**Todos os itens, exceto o 'informações complementares'*/
                        AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                  WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                    AND NRORG    = VM.NRORG
                                                    AND NRPESSOA = PE.NRPESSOA )
                        AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                  WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                    AND NRORG      = VM.NRORG
                                                    AND NRVINCULOM = VM.NRVINCULOM )
                        $condEstrutLegal
                        $condEstrutGeren
                ) RES
                WHERE 1=1
                $conditions
                $group
          ) GPE_VINCULOM
          
        ");
      $query->execute(
        array(
          "P_COMPETENCIA"    => $parameters['P_DTMESCOMPETENC'],
          "P_NRORG"          => $parameters['P_NRORG'],
          "P_NRTPMODALIDCAL" => $parameters['NRTPMODALIDCAL'],
          "P_NRGRPDIRF"      => $parameters['NRGRPDIRF'] // 10
        )
      );

      return $query->fetchAll();
    }
}

