<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 02/03/2016
 * Time: 16:57
 */

namespace HCM\Geral\Controllers;

use HCM\Util\Util;
use \Zeedhi\Framework\DTO\Response;

class ReferencesGeraisController {

    protected $referencesGeraisServices;

    public function __construct(\HCM\Geral\Services\ReferencesGeraisServices $referencesGeraisServices) {
        $this->referencesGeraisServices = $referencesGeraisServices;
    }

    public function getEstadocivil($request, $response) {

        try {

            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }

            $result = $this->referencesGeraisServices->getEstadocivil($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getEstadocivil', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getNacionalidade($request, $response) {

        try {

            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }

            $result = $this->referencesGeraisServices->getNacionalidade($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getNacionalidade', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getSimNao($request, $response) {

        try {
            $result = $this->referencesGeraisServices->getSimNao();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getSimNao', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getGrauintrucao($request, $response) {

        try {
            $result = $this->referencesGeraisServices->getGrauintrucao();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getGrauintrucao', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getFormaComnunicacao($request, $response) {

        try {
            $result = $this->referencesGeraisServices->getFormaComnunicacao();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getFormaComnunicacao', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getPais($request, $response) {

        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $conditions = Util::createQueryFiltered($filters);
            $result = $this->referencesGeraisServices->getPais($conditions);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getPais', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getMunicipio($request, $response) {

        try {
            $result = $this->referencesGeraisServices->getMunicipio();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getMunicipio', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function getOrganizacoesOper($request, $response) {
        
        try {
            $result = $this->referencesGeraisServices->getOrganizacoesOper();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getOrganizacoesOper', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }        
    }

    public function getEstruturasOper($request, $response) {
        
        try {
            $result = $this->referencesGeraisServices->getEstruturasOper();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getEstruturasOper', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }        
    }

}