<?php

namespace HCM\Geral\Entity;

use HCM\Util\TkEntity;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use Teknisa\Model\Gestaopessoas\Entities\Gpealtestabvinc;

/**
 * GpeAltestabvincEntity.
 *
 * @package Entity
 *
 * @author  arturcoelho
 *
 */
class GpeAltestabvincEntity extends TkEntity
{

    private $_nrOrgTrabalho;
    private $_nrOrgPadrao;
    private $_mesCompetencia;


    /**
     * Construtor.
     *
     * @param integer $id            Identificador.
     * @param integer $nrOrgPadrao   Numero da Organizacao Padrao.
     * @param integer $nrOrgTrabalho Numero da Organizacao de Trabalho.
     *
     * @author felipesantos - 05/07/2011
     */
    public function __construct($entityManager, $hcmParameters){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrgTrabalho = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $this->hcmParameters->getDtCompetencia();
        $this->alteEstab = Repositories::GPE_ALTESTABVINC;
        
        parent::__construct(null, $entityManager);
    }

    public function retornaEstabilidadePorPeriodo($nrorg, $nrvinculom, $dtiniperiodo, $dtfimperiodo) {
        $altestabvinc = \Gpealtestabvinc::getEstabilidadePorPeriodo(
            $nrorg, $nrvinculom, $dtiniperiodo, $dtfimperiodo
        );
        return $altestabvinc;
    }
    
     public function verificaEstabilidadeCalculo($nrorg, $nrvinculom, $dtrescisao) {
        
        $estabilidades =  $this->entityManager->getRepository(Repositories::GPE_ALTESTABVINC)->findBy(array('nrorg' => $nrorg, 'nrvinculom' => $nrvinculom));
        
        if($estabilidades){
            foreach($estabilidades as $estabilidade){
                $dtInicio = $estabilidade->getDtiniestabvinc();
                $dtFim = $estabilidade->getDtfimestabvinc();
                
                if($dtInicio && $dtFim && $dtrescisao){
                    if(DateUtil::isBetween($dtrescisao, $dtInicio, $dtFim)){
                        return true;
                    }
                }
            }
        }
        
        return false;
    }
    
}