<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\GpeTipocomitetiporeuniao;
use Folha\Entities\GpeTipocomiteocup;
use Folha\Entities\GpeTipocomite;
use Folha\Entities\GpeTipodireitoocupcomite;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class TipoComiteService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteTipoComite($dataset) {
        
        $nrorg = $dataset["NRORG"];
        $nrtipocomite = $dataset["NRTIPOCOMITE"];

        $reuniao = GpeTipocomitetiporeuniao::findByNrtipocomiteAndNrorg($nrtipocomite, $nrorg);
        $ocupacao = GpeTipocomiteocup::findByNrtipocomiteAndNrorg($nrtipocomite, $nrorg);
        
        if (isset($reuniao[0])) {
            throw new \Exception("Existe tipo de reunião relacionada à este tipo de comitê.", 10);
        }else if (isset($ocupacao[0])) {
            throw new \Exception("Existe ocupação relacionada à este tipo de comitê.", 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $tipocomite = GpeTipocomite::findOneByNrtipocomiteAndNrorg($nrtipocomite, $nrorg);
            $this->entityManager->remove($tipocomite);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
    
    public function deleteOcupacao($dataset) {
        $nrorg = $dataset["NRORG"];
        $nrocupacao = $dataset["NRTIPOCOMITEOCUP"];
        $tipodireito = GpeTipodireitoocupcomite::findByNrtipocomiteocupAndNrorg($nrocupacao, $nrorg);
        if (isset($tipodireito[0])) {
            throw new \Exception("Existe tipo de direito relacionado à este tipo de ocupação.", 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $tipoocupacao = GpeTipocomiteocup::findOneByNrtipocomiteocupAndNrorg($nrocupacao, $nrorg);
            $this->entityManager->remove($tipoocupacao);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
    
    public function validaTipoDireitoCadastrado($dataset) {
        $nrorg = $dataset["NRORG"];
        $nrocupacao = $dataset["NRTIPOCOMITEOCUP"];
        $nrtipodireitoocupcomite = $dataset['NRTIPODIREITOOCUPCOMITE'];
        $nrtipodireito = $dataset['NRTIPODIREITO'];
        
        $tipodireito = $this->entityManager->getRepository(Repositories::GPE_TIPODIREITOOCUPCOMITE)->getTipoDireitoComiteOcup($nrorg, $nrtipodireitoocupcomite, $nrocupacao, $nrtipodireito);
        // $tipodireito = GpeTipodireitoocupcomite::findByNrtipocomiteocupAndNrorg($nrocupacao, $nrorg);
        
        if (isset($tipodireito[0])) {
            throw new \Exception("Existe tipo de direito cadastrado para essa ocupação.", 10);
        }
    }
}