<?php
namespace Estoque\Entities;

class Inverota extends Base\Inverota
{


    /**
     * Insere Inventario rotativo com as quantidades zeradas.
     *
     * @param $nrorg
     * @param $filial
     * @param $dtInventario
     * @param $almox
     * @param $local
     * @param $produto
     * @param $dataAtual
     * @param $operador
     *
     * @return int
     */
    public function insereInventarioRotativo(
        $nrorg, $filial, $dtInventario, $qtdEstoque, $qtdInvent, $almox, $local, $produto, $dataAtual, $operador
    ){
        if (is_object($dtInventario) === false) {
            $dtInventario = \Geral\Util\DateUtil::getDataDeString($dtInventario);
        }

        if (is_object($dataAtual) === false) {
            $dataAtual = \Geral\Util\DateUtil::getDataDeString($dataAtual);
        }

        $objLocalEstoque = \Geral\Entities\Localestoque::getObject(
            array(
                'cdfilial' => $filial,
                'cdalmoxarife' => $almox,
                'cdlocalestoq' => $local,
                'nrorg' => $nrorg,
            )
        );

        $objProduto = \Geral\Entities\Produto::getObject(
            array(
                'cdproduto' => $produto,
                'nrorg' => $nrorg,
            )
        );

        $this->setLocalestoq($objLocalEstoque);
        $this->setCdoperinclusao($operador);
        $this->setProduto($objProduto);
        $this->setDtinclusao($dataAtual);
        $this->setDtinverota($dtInventario);
        $this->setQtestoque($qtdEstoque);
        $this->setQtinverota($qtdInvent);
        $this->setNrorginclusao($nrorg);

        $this->persist();
    }


}